#include <iostream>
#include <string>
#include <fstream>

#include "epplet.h"

int pos1, pos2, pos3;
int prev_val = 0;
int load_val = 0;
char *apm_label = "eApm";
Epplet_gadget      *load     = NULL;
Epplet_gadget *percent_label = NULL;
Epplet_gadget p, pop, help_button;
char *online_image; // = "/home/nedor/prog/cpp/eApm/online.png";
char *offline_image; // = "/home/nedor/prog/cpp/eApm/offline.png";
char *image_to_show;
static string s, str, s1;

static void cb_timer(void *data);
static void cb_close(void *data);

void cb_configure(void *data)
{
	cout << "configure\n";
}

/* the suspend and stanby modes are not used */

void cb_suspend(void *data)
{
	system("apm --suspend");
}

void cb_standby(void *data)
{
	system("apm --standby");
}

/*********************************************/

void cb_about(void *data)
{
	Epplet_show_about("eApm");
}

void read_config_file(bool query) 
{
	
	char *file_location = malloc(strlen(getenv("HOME")) + 7);
	sprintf(file_location, "%s/%s", getenv("HOME"), ".eApmrc");
//	s = "";
        std::ifstream eApmrc;
	eApmrc.open(file_location);
	if(!eApmrc) {
		std::ofstream newrc;
		newrc.open(file_location);
		newrc << "online_image=/usr/share/enlightenment/epplet_icons/online.png\n";
		newrc << "offline_image=/usr/share/enlightenment/epplet_icons/offline.png\n";
		newrc.close();
		eApmrc.open(file_location);
	}
	while(!eApmrc.eof()) {
		std::getline(eApmrc, s, '\n');
		pos1 = s.find("online_image=");	
		if(pos1 == 0) {
			s.replace(pos1, 13, "");	
			pos2 = s.find_last_not_of(' ') + 1;
			pos3 = s.find_first_of('\n');
//			s.replace(pos2, pos3, "");
			online_image = s.c_str();
			if(query)
			       return;
		}
	
		else {
			pos1 = s.find("offline_image=");
			if(pos1 == 0) {
				s.replace(pos1, 14, "");
				pos2 = s.find_last_not_of(' ');
				pos3 = s.find_first_of('\n') + 1;
//				s.replace(pos2, pos3, "");
				offline_image = s.c_str();
			}
		}
	}
}
	
static void cb_timer(void *data)
{
	
   	int i;
	int pos1, pos2, pos3;
	string percent_remaining, minutes_remaining, str_label, off_on_line;
	
	int val, val2;

	std::ifstream fapm;
	fapm.open("/proc/apm");	
	std::getline(fapm, str, '\n');

	/* Get the Percent remaining */
	percent_remaining = str;	
	pos1 = percent_remaining.find_first_of('%');
	pos2 = percent_remaining.find_first_of('\n');
	percent_remaining.replace(pos1, pos2, "");
	pos3 = percent_remaining.find_last_of(' ');
	percent_remaining.replace(0, pos3 + 1, "");

	val = atoi(percent_remaining.c_str());
	
     	val2 = val - prev_val;
     	prev_val = val;
     	if (val2 > 100)
		val2 = 100;	
	if (val2 < 0)
		val2 = 0;
	
	if(val > 100)
		val = 100;
	if(val < 0)
		val = 0;
		
     	load_val = val;
     	Epplet_gadget_data_changed(load);

     	percent_remaining.append("%");

	 
	minutes_remaining = str;
	pos1 = minutes_remaining.find(" min");
	pos2 = minutes_remaining.find_first_of('\n');
	if(pos1 != -1) {	  
		minutes_remaining.replace(pos1, pos2, "");	
		pos3 = minutes_remaining.find_last_of(' ');
		minutes_remaining.replace(0, pos3 + 1, "");   	
		str_label = minutes_remaining;
		str_label.append(" min ");
		str_label.append(percent_remaining);
		apm_label = str_label.c_str();
	}
	else {
		apm_label = "eApm - No Bat";
	}
	Epplet_change_label(percent_label, apm_label);
        
	
	/* find out if we are on or offline */
	/* 
	 * I thought I had figured out how what 
	 * the /proc/apm file says about being 
	 * on and offline. I hadn't, so I am using
	 * the "apm" command for now
	 * if you know how to fix it let me know
	 * Ted Roden <ted@slapfactory.com>
	 */
        	
	
	system("apm > /tmp/eApm.tmp");
	std::ifstream tmp;
	tmp.open("/tmp/eApm.tmp");
	std::getline(tmp, s1, '\n');
	off_on_line = s1;
	pos1 = off_on_line.find_first_of(' ') + 1;
	pos2 = off_on_line.find_first_of(',');
	pos3 = off_on_line.find_first_of('\n');
	off_on_line.replace(pos2, pos3, "");
	off_on_line.replace(0, pos1, "");
	read_config_file(NULL);
	if(off_on_line == "off-line") {
		read_config_file(false);
		image_to_show = offline_image;
	}
	else {
		read_config_file(true);
		image_to_show = online_image;
	}
	Epplet_gadget_destroy(help_button);
	help_button = Epplet_create_button(NULL, image_to_show,
		       			65, 16, 14, 14, 0, 0, NULL,
 		       			cb_about, NULL);
	Epplet_gadget_show(help_button);
	
	Esync();
	Epplet_timer(cb_timer, NULL, 20.0, "TIMER");   
	fapm.close();     
   	data = NULL;
}

static void
cb_close(void *data)
{
   Epplet_unremember();
   Esync();
   exit(0);
}


int main(int argc, char **argv)
{
   	int i = 1;

   	load_val = malloc(sizeof(int));
   	prev_val = malloc(sizeof(int));
   	load     = malloc(sizeof(Epplet_gadget));
   	load_val = 6;
	percent_label = malloc(sizeof(Epplet_gadget));
	help_button = malloc(sizeof(Epplet_gadget));

//	read_config_file(NULL);
	
   	Epplet_Init("eApm", "0.1", "Enlightened Apm monitor",
			5, 2, argc, argv, 0);
	Epplet_timer(cb_timer, NULL, 0.5, "TIMER");
   	Epplet_gadget_show(Epplet_create_button(NULL, NULL,
					   2, 2, 0, 0, "CLOSE", 0, NULL,
					   cb_close, NULL));
	
/*       
 *	p = Epplet_create_popup();
 *	Epplet_add_popup_entry(p, "Suspend", NULL, cb_suspend, NULL);
 *	Epplet_add_popup_entry(p, "Configure", NULL, cb_about, NULL);
 *	Epplet_add_popup_entry(p, "About", NULL, cb_configure, NULL);
 *
 *	pop = Epplet_create_popupbutton("Cfg", NULL, 55, 16, 20, 12, p);
 *
 *	Epplet_gadget_show(pop);
 */
	

 	help_button = Epplet_create_button(NULL, image_to_show,
 		       			65, 16, 14, 14, 0, 0, NULL,
 		       			cb_about, NULL);
	Epplet_gadget_show(help_button);
 	
 	load = Epplet_create_hbar(16, 1, 62, 12, 0, &(load_val));
 	percent_label = Epplet_create_label(3, 19, apm_label, 0);
 	
 	Epplet_gadget_show(percent_label);
	Epplet_gadget_show(load);

   	Epplet_show();
   	Epplet_Loop();
   	return 0;
}
